%define pgpver 0.13.1

Summary: A commonly used, MIME compliant mail and news reader.
Name: pine
Version: 4.21
Release: 23
Copyright: Freely Distributable
Url: http://www.washington.edu/pine/
Group: Applications/Internet
Source0: ftp://ftp.cac.washington.edu/pine/pine%{version}.tar.gz
Source1: http://www.megaloman.com/~hany/_data/pinepgp/pinepgp-%{pgpver}.tar.gz
Source2: pine.conf
Source3: ftp://ftp.cac.washington.edu/imap/imap-4.7c2.tar.Z
Source4: ftp://ftp.cac.washington.edu/imap/simap-4.7.tar
Source5: flock.c
Patch0: pine4.20-redhat.patch
# XXX is sigchild patch still necessary???
Patch3: pine-3.96-sigchld.patch
Patch5: pine-4.02-filter.patch
Patch6: pine4.04-noflock.patch
Patch8: pine4.20-maildir.patch
Patch9: pine4.21-maildirfix.patch
Patch10: pine4.21-krb5-111.patch
Patch11: pine-4.21-fixhome.patch
Patch12: pine4.21-compile.patch 
Patch13: simap-4.7-dynamic.patch 
Patch14: imap-4.7c2-flock.patch 
Buildroot: %{_tmppath}/pine-%{version}-root
BuildPrereq: perl, openssl-devel
%{!?noldap:BuildPrereq: openldap-devel}
%{!?nokerberos:BuildPrereq: krb5-devel}
%{!?nokerberos:Requires: krb5-libs}

%description
Pine is a very popular, easy to use, full-featured email user agent
which includes a simple text editor called pico. Pine supports MIME
extensions and can also be used to read news.  Pine also supports
IMAP, mail and MH style folders.

Pine should be installed because Pine is a very commonly used email
user agent.

%prep
%setup -q -n pine%{version} -a 1 -a 3 -a 4
chmod -R u+w .

pushd simap-4.7
%patch13 -p1 -b .dynamic
popd

mv imap imap-pine-%{version}
mv imap-4.7c imap
cp simap-4.7/unix/* imap/src/c-client/

%patch0 -p1 -b .glibc
%patch5 -p1 -b .filter
%patch6 -p1 -b .noflock
#%patch8 -p1 -b .maildir
#%patch9 -p1 -b .maildirfix
%{!?nokerberos:%patch10 -p1 -b .krb5-111}
%patch11 -p1 -b .fixhome
%patch12 -p1 -b .compile

pushd imap
%patch14 -p1 -b .flock
cp %{SOURCE5} src/osdep/unix
popd

# this wants /usr/local/bin/perl
chmod 644 contrib/utils/pwd2pine

%{?!nokerberos: rm -f krb5 && ln -s /usr/kerberos krb5}
%{?!nokerberos: ./contrib/krb5-setup slx slx}

%{?!noldap:rm -fr ldap && mkdir ldap && ln -s /usr/lib ldap/libraries && ln -s /usr/include ldap/include}
%{?!noldap:./contrib/ldap-setup slx slx || true}

%build
perl -pi -e "s/-g -fno-omit-frame-pointer -O6/$RPM_OPT_FLAGS/" \
	c-client/Makefile imap/src/osdep/unix/Makefile imap/c-client/Makefile

./build \
	DEBUG="" \
%ifarch ia64
	OPTIMIZE="-O" \
%elsevi 
	OPTIMIZE="$RPM_OPT_FLAGS" \
%endif
	EXTRACFLAGS="-DIGNORE_LOCK_EACCES_ERRORS" \
%{!?nokerberos:EXTRAAUTHENTICATORS=gss} \
	SPECIALAUTHENTICATORS=ssl \
	slx

cd pinepgp-%{pgpver}
make

%install
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/usr/bin $RPM_BUILD_ROOT/%{_mandir}/man1
mkdir -p $RPM_BUILD_ROOT/usr/doc $RPM_BUILD_ROOT/usr/lib
install -c -m 644 doc/mime.types $RPM_BUILD_ROOT/usr/lib/mime.types
for n in pine pico pilot; do
    install -c -m 755 -s bin/$n $RPM_BUILD_ROOT/usr/bin/$n
done

cd pinepgp-%{pgpver}
make install-gpg prefix=$RPM_BUILD_ROOT/usr
cd ..

cd doc
for n in pine.1 pico.1 pilot.1; do
    install -m 644 $n $RPM_BUILD_ROOT/%{_mandir}/man1
done
mkdir -p $RPM_BUILD_ROOT/etc
install -m644 %{SOURCE2} $RPM_BUILD_ROOT/etc/pine.conf
cat <<EOF > $RPM_BUILD_ROOT/etc/pine.conf.fixed
#
# Pine system-wide enforced configuration file - customize as needed
#
# This file holds the system-wide enforced values for pine configuration
# settings. Any values set in it will override values set in the
# system-wide default configuration file (/etc/pine.conf) and
# the user's own configuration file (~/.pinerc).
# For more information on the format of this file, read the
# comments at the top of /usr/lib/pine.conf

EOF

%clean
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%doc README CPYRIGHT doc/*.txt doc/pine-ports doc/tech-notes doc/mailcap.unx contrib
/usr/bin/pine
/usr/bin/pico
/usr/bin/pilot
/usr/bin/gpg-check
/usr/bin/gpg-sign
/usr/bin/gpg-encrypt
/usr/bin/gpg-sign+encrypt
/usr/bin/pinegpg
%{_mandir}/man1/pico.1*
%{_mandir}/man1/pine.1*
%{_mandir}/man1/pilot.1*
%attr(0644,root,root)	%config /usr/lib/mime.types
%attr(0644,root,root)	%config /etc/pine.conf
%attr(0644,root,root)	%config /etc/pine.conf.fixed

%changelog
* Thu Aug 24 2000 Nalin Dahyabhai <nalin@redhat.com>
- use flock()-over-fcntl() locking emulation (#15779)

* Wed Aug 23 2000 Nalin Dahyabhai <nalin@redhat.com>
- enable SSL via simap

* Mon Jul 19 2000 Trond Eivind Glomsrd <teg@redhat.com>
- don't map ctrl-d to delete, as it currently makes
  backspace work like delete

* Wed Jul 12 2000 Prospector <bugzilla@redhat.com>
- automatic rebuild

* Tue Jun 27 2000 Nalin Dahyabhai <nalin@redhat.com>
- Rebuild in new environment (release 19)

* Mon Jun 19 2000 Trond Eivind Glomsrd <teg@redhat.com>
- Use aspell by default

* Wed Jun 14 2000 Trond Eivind Glomsrd <teg@redhat.com>
- New patch to make it compile with new glibc.

* Thu Jun 08 2000 Trond Eivind Glomsrd <teg@redhat.com>
- remove applnk entry
- use %%{_mandir} and %%{_tmppath}

* Wed May 10 2000 Nalin Dahyabhai <nalin@redhat.com>
- reverse sense of enabling kerberos support
- make ldap support optional, though it's built statically

* Fri May  5 2000 Bill Nottingham <notting@redhat.com>
- work around a compiler bug on ia64

* Thu May 04 2000 Trond Eivind Glomsrd <teg@redhat.com>
- enable the 8-bit options by default (esmtp and nntp)
- use ISO-8859-1 as default character set instead of
  US-ASCII
- map delete to ctrl-d

* Thu Apr 27 2000 Trond Eivind Glomsrd <teg@redhat.com>
- update pinepgp to 0.13.1
- don't apply the maildir patches, as they can make pine
  crash if it finds recusive symlinks (bug #9736)

* Tue Apr 18 2000 Trond Eivind Glomsrd <teg@redhat.com>
- remove bogus entry from pine.conf

* Tue Apr  4 2000 Bill Nottingham <notting@redhat.com>
- eliminate explicit krb5-configs dependency

* Fri Mar 24 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- rebuild with current ncurses
- add gnupg support

* Tue Mar 07 2000 Preston Brown <pbrown@redhat.com>
- fix home key in pico/pine

* Wed Mar  1 2000 Nalin Dahyabhai <nalin@redhat.com>
- make kerberos support conditional at build-time
- remove build prereq krb5-devel

* Wed Mar  1 2000 Bill Nottingham <notting@redhat.com>
- integrate kerberos support into main tree

* Fri Feb 23 2000 Nalin Dahyabhai <nalin@redhat.com>
- add GSS authenticator
- BuildPrereq: krb5-devel

* Thu Feb 17 2000 Bernhard Rosenkrnzer <bero@redhat.com>
- Fix up maildir patch (Bug #6002)
- BuildPrereq: openldap-devel

* Thu Feb 10 2000 Nalin Dahyabhai <nalin@redhat.com>
- rebuild

* Mon Feb 07 2000 Preston Brown <pbrown@redhat.com>
- wmconfig -> desktop

* Wed Feb 02 2000 Cristian Gafton <gafton@redhat.com>
- fix description
- man pages are compressed

* Fri Jan 21 2000 Preston Brown <pbrown@redhat.com>
- remove enable mouse in xterm config setting.

* Wed Nov 24 1999 Bernhard Rosenkraenzer <bero@redhat.com>
- 4.21
- remove ioctl patch, it's no longer necessary

* Tue Nov  2 1999 Bernhard Rosenkraenzer <bero@redhat.com>
- Provide a more reasonable /etc/pine.conf, allowing stuff like
  tab completion, full header command, ...
- handle RPM_OPT_FLAGS

* Wed Oct 13 1999 Preston Brown <pbrown@redhat.com>
- pine 4.20, updated glibc and maildir patches

* Thu Aug 12 1999 Cristian Gafton <gafton@redhat.com>
- add maildir patch

* Sun Mar 21 1999 Cristian Gafton <gafton@redhat.com> 
- auto rebuild in the new build environment (release 2)

* Fri Feb 26 1999 Cristian Gafton <gafton@redhat.com>
- fix buildroot and add cleanup section
- move config files to /etc/pine.conf

* Tue Feb 02 1999 Preston Brown <pbrown@redhat.com>
- turned off .pine-debugX files

* Thu Dec 17 1998 Cristian Gafton <gafton@redhat.com>
- build against glibc 2.1

* Fri Nov 13 1998 Cristian Gafton <gafton@redhat.com>
- patch to enable SIGWINCH processing (why do the pine folks keep 
  disabling this stuff?!)

* Fri Oct 09 1998 Cristian Gafton <gafton@redhat.com>
- use termios instead of termio (patch used to be in here...)
- use terminfo instead of termcap and link against ncurses instead of termcap
- supply -lcrypt as a standard lib

* Sat Sep 19 1998 Jeff Johnson <jbj@redhat.com>
- upgrade to 4.04 (compatibility with some client imaps).

* Fri Sep 11 1998 Jeff Johnson <jbj@redhat.com>
- use only fcntl locking.

* Thu Sep 10 1998 Jeff Johnson <jbj@redhat.com>
- update to 4.03

* Fri Aug 14 1998 Jeff Johnson <jbj@redhat.com>
- patch to 4.02A.
- disable stupid EACCESS warnings.

* Wed Jul 22 1998 Jeff Johnson <jbj@redhat.com>
- update to 4.02.

* Mon Apr 27 1998 Prospector System <bugs@redhat.com>
- translations modified for de, fr, tr

* Thu Jan 15 1998 Erik Troan <ewt@redhat.com>
- added patch to fix pine filters

* Tue Dec 30 1997 Erik Troan <ewt@redhat.com>
- fixed resizing in pine and pico

* Thu Dec 18 1997 Erik Troan <ewt@redhat.com>
- removed patch for SIGCHLD race -- it shouldn't be necessary
- added patch to avoid longjmp() from SIGCHLD handler -- SIGCHLD handling
  is sane now

* Thu Dec 11 1997 Cristian Gafton <gafton@redhat.com>
- added a patch for handling a SIGCHLD race condition

* Tue Nov 04 1997 Erik Troan <ewt@redhat.com>
- fix for locks w/ long st_dev field
- use termios rather then termio

* Wed Oct 29 1997 Donnie Barnes <djb@redhat.com>
- added wmconfig entry

* Fri Oct 10 1997 Erik Troan <ewt@redhat.com>
- removed exec bit from /usr/doc/pine-3.96-1/contrib/utils/pwd2pine
